#include <system/api.h>
#include "layout.h"

t_system_colors theme = {0};
t_Container *mainLayout = NULL;

void mainwnd_draw(void)
{
	kos_WindowRedrawStart();
	
	kos_DefineAndDrawWindow(-1, -1, 400, 300, 0x33000000 | theme.win_body, 0, "Layout test");
	
	t_thread_info *ti = kos_GetThreadInfo(-1);
	t_rect rc;
	rc.left = 0;
	rc.top = 0;
	rc.right = ti->client_area_size.width;
	rc.bottom = ti->client_area_size.height;
	if (mainLayout)
	{
		widget_set_size(mainLayout, &rc);
		widget_invalidate(mainLayout, &rc);
	}
	
	kos_HeapFree(ti);
	
	kos_WindowRedrawFinish();
}

void mainwnd_run(void)
{
	while (1)
	{
		int event = kos_WaitForEvent();
		switch (event)
		{
			case SYSEVENT_WNDREDRAW:
			{
				mainwnd_draw();
				break;
			}
			
			case SYSEVENT_BTNPRESS:
			{
				int btn_id = kos_GetPressedButtonId();
				if (btn_id == BUTTONID_EXIT)
					return;
				break;
			}
		}
	}
}

int main(int argc, char **argv)
{
	if (!kos_HeapInit()) {
		kos_ExitApp();
	}
	kos_GetSystemColors(&theme);
	
	mainLayout = vcontainer_create();
	mainLayout->expand = EXPAND_HORIZONTAL | EXPAND_VERTICAL;
	
	t_Container *h1 = hcontainer_create();
	h1->expand = EXPAND_HORIZONTAL | EXPAND_VERTICAL;

	t_Widget *btn1 = button_create("Button 1", 101, 110, 25, &theme);
	btn1->alignment = ALIGNMENT_LEFT;
	container_add_child(h1, btn1);
	
	t_Widget *btn2 = button_create("Button 2", 102, 110, 25, &theme);
	btn2->alignment = ALIGNMENT_CENTER;
	container_add_child(h1, btn2);
	
	t_Widget *btn3 = button_create("Button 3", 103, 110, 25, &theme);
	btn3->alignment = ALIGNMENT_RIGHT;
	container_add_child(h1, btn3);	

	container_add_child(h1, spacer_create());
	
	t_Widget *btn4 = button_create("Exit", 1, 100, 25, &theme);
	btn4->expand = EXPAND_HORIZONTAL;
	container_add_child(h1, btn4);
	
	container_add_child(mainLayout, h1);
	
	mainwnd_draw();
	mainwnd_run();

	kos_ExitApp();
	return 0;
}