#ifndef __LAYOUT_H
#define __LAYOUT_H

#define LAYOUT_API __stdcall

#define EXPAND_NONE       0
#define EXPAND_VERTICAL   1
#define EXPAND_HORIZONTAL 2

#define ALIGNMENT_LEFT    0x1
#define ALIGNMENT_CENTER  0x2
#define ALIGNMENT_RIGHT   0x4
#define ALIGNMENT_TOP     0x10
#define ALIGNMENT_VCENTER 0x20
#define ALIGNMENT_BOTTOM  0x40

/*typedef struct {
	uint16_t left, top, right, bottom;
} t_rect;*/

typedef void (* LAYOUT_API t_RecalcFunc)(void*);
typedef void (* LAYOUT_API t_DrawFunc)(void*, t_rect*);

#define WIDGET_FIELDS  \
	size_t left, top; \
	size_t width, height; \
	size_t min_width, min_height; \
	size_t req_width, req_height; \
	size_t expand; \
	size_t alignment; \
 \
	size_t visible; \
	size_t isContainer; \
	 \
	void *custom_data; \
 \
	t_DrawFunc lpDrawFunc; \
	t_RecalcFunc lpRecalcFunc; 

typedef struct {
	/*size_t left, top;
	size_t width, height;
	size_t min_width, min_height;
	size_t req_width, req_height;
	size_t expand;
	size_t alignment;

	size_t visible;
	size_t isContainer;
	
	void *custom_data;

	void (*lpDrawFunc)(void*, t_rect*);
	void (*lpRecalcFunc)(void*);*/
	WIDGET_FIELDS
} t_Widget;

typedef struct {
	//t_Widget _;
	WIDGET_FIELDS
	size_t countOfChilds;
	void* *childs;
} t_Container;


void LAYOUT_API layout_set_margin(size_t val);
t_Container * LAYOUT_API container_create(t_RecalcFunc lpRecalcFunc, t_DrawFunc lpDrawFunc);
void LAYOUT_API container_add_child(t_Container *c, void *w);
void LAYOUT_API container_free(void* this);
t_Container * LAYOUT_API vcontainer_create(void);
t_Container * LAYOUT_API hcontainer_create(void);
t_Widget * LAYOUT_API widget_create(t_rect* rc, t_DrawFunc lpDrawFunc);
void LAYOUT_API widget_set_size(void* this, t_rect* rc);
void LAYOUT_API widget_invalidate(void* this, t_rect* rc);
void LAYOUT_API widget_free(void* this);
t_Widget * LAYOUT_API button_create(char *text, int id, size_t width, size_t height, void *sys_colors);
void LAYOUT_API button_free(void* this);
t_Widget * LAYOUT_API spacer_create(void);
void LAYOUT_API spacer_free(void* this);

#endif //__LAYOUT_H